!	MKVFONT -- create vector font files from VF descriptions.
!	Copyright (C) 1995 Nils M. Holm

module mkvfont(t3x, string, iostream, char, util);

object	t[t3x], str[string], chr[char], u[util];

const	BUFLEN = 1024;

object	In[iostream], Out[iostream];
var	InBuf::BUFLEN, OutBuf::BUFLEN;

usage() do var m, nl::4;
	m := "Usage: mkvfont x y VFD-file VF-file";
	u.writef(T3X.SYSERR, "Usage: mkvfont x y VFD-file VF-file%s",
		[(t.newline(nl))]);
	halt 1;
end

getnum() do var c, v;
	while (1) do
		c := In.rdch();
		if (\chr.space(c)) leave;
	end
	v := 0;
	while (chr.digit(c)) do
		v := v * 10 + chr.value(c);
		c := In.rdch();
	end
	return v;
end

do
	var	i, j, k, buf[256], c, x, y;
	var	buffer::256, nl::4;
	var	infile::256, outfile::256, abuf::256;

	if (t.getarg(1, abuf, 256) < 1) usage();
	x := str.strtonum(abuf, 10, 0);
	if (t.getarg(2, abuf, 256) < 1) usage();
	y := str.strtonum(abuf, 10, 0);
	if (t.getarg(3, infile, 256) < 1) usage();
	if (t.getarg(4, outfile, 256) < 1) usage();
	if (In.open(infile, InBuf, BUFLEN, IOSTREAM.FREAD|IOSTREAM.FKILLCR)
		= -1
	)
	do
		u.writef(T3X.SYSERR, "mkvfont: %s: cannot open%s",
			[(infile, t.newline(nl)]);
		halt 1;
	end
	if (Out.open(outfile, OutBuf, BUFLEN, IOSTREAM.FWRITE) = -1) do
		u.writef(T3X.SYSERR, "mkvfont: %s: cannot create%s",
			[(outfile, t.newline(nl)]);
		halt 1;
	end
	Out.writes("VF10");
	Out.wrch(x);
	Out.wrch(y);
	for (i=32, 128) do
		while (1) do
			c := In.rdch();
			ie (c = ';' \/ c = '\n')
				In.reads(buffer, 256);
			else
				leave;
		end
		if (In.eof()) leave;
		buf[0] := getnum();
		for (j=0, buf[0]) do
			k := getnum();
			buf[j+1] := (k >= 100)-> 0x80: 0;
			if (k>=100) k := k-100;
			buf[j+1] := buf[j+1] | ((k/10)<<4);
			while (k>=10) k := k-10;
			buf[j+1] := buf[j+1] | k;
		end
		for (k=0, j+1) Out.wrch(buf[k]);
	end
	In.close();
	Out.close();
end
