! TIDE -- File services class
! Copyright (C) 2003 Nils M Holm. All rights reserved.
! See the file LICENSE for conditions of use.

module filesrv();

public class filesrv(t3x, string)

 object	t[t3x], str[string];

 public const	E_OK		=  0,
		E_OPEN		= -1,
		E_CREATE	= -2,
		E_READ		= -3,
		E_WRITE		= -4,
		E_DELETE	= -5;

 public exists(name) do var fd;
	fd := t.open(name, T3X.OREAD);
	if (fd < 0) return 0;
	t.close(fd);
	return -1;
 end

 public delete(name) return t.remove(name)-> E_DELETE: E_OK;

 docopy(source, dest, buf, len, append) do
	var	in, out;
	var	r, k, k2;

	in := t.open(source, T3X.OREAD);
	if (in < 0) return E_OPEN;
	out := t.open(dest, append-> T3X.OAPPND: T3X.OWRITE);
	if (out < 0) do
		t.close(in);
		return append-> E_OPEN: E_CREATE;
	end
	r := E_OK;
	while (1) do
		k := t.read(in, buf, len);
		if (k < 0) do
			r := E_READ;
			leave;
		end
		if (k = 0) return;
		k2 := t.write(out, buf, k);
		if (k2 \= k) do
			r := E_WRITE;
			leave;
		end
	end
	if (r /\ \append) self.delete(dest);
	t.close(in);
	t.close(out);
	return r;
 end

 public copy(source, dest, buf, len)
	docopy(source, dest, buf, len, 0);

 public append(source, dest, buf, len)
	docopy(source, dest, buf, len, 1);

 public move(source, dest) do var buf::256, r;
	if (\self.exists(source)) return E_OPEN;
	t.remove(dest);
	if (t.rename(source, dest) = 0) return E_OK;
	r := self.copy(source, dest, buf, 256);
	if (r \= E_OK) return r;
	return self.delete(source);
 end

end

do end
