! TIDE -- Menu class
! Copyright (C) 2000,2002 Nils M Holm. All rights reserved.
! See the file LICENSE for conditions of use.

module menu();

public class menu(t3x, string, ttyctl)

 object t[t3x], str[string], tty[ttyctl];

 const MAXWIDTH = 80;

 public struct	CSET = C_BACKGROUND, C_FRAME, C_TEXT, C_SOTEXT, C_SELECT;
 public struct	FSET = F_UL, F_UR, F_LL, F_LR, F_HL, F_VL;

 var	Dflcset, Dflfset;
 var	Colorset, Frameset;
 var	Spaces::MAXWIDTH+1;

 init() do
	tty.init();
	tty.mode(1);
	Dflcset := [
		ttyctl.F_BLACK|ttyctl.B_GREY,	! Background
		ttyctl.F_BLACK|ttyctl.B_GREY,	! Frame
		ttyctl.F_BLACK|ttyctl.B_GREY,	! Text
		ttyctl.F_GREY|ttyctl.B_BLACK,	! SO text
		ttyctl.F_GREY|ttyctl.B_BLACK,	! Select
	];
	Dflfset := [ '\s', '\s', '\s', '\s', '\s', '\s' ];
 end

 fini() do
	tty.mode(0);
	tty.fini();
 end

 writeitem(x, y, item, on) do
	tty.color(on-> Colorset[C_SELECT]: Colorset[C_TEXT]);
	tty.move(x, y);
	tty.writes(item);
	tty.writes(@Spaces::(str.length(item)+4));
 end

 framebox(x, y, dx, dy) do var i, line::MAXWIDTH;
	tty.color(Colorset[C_FRAME]);
	for (i=y, dy) do
		tty.move(x, i);
		tty.writes(Spaces);
	end
	t.memfill(line, Frameset::F_HL, dx-x);
	line::(dx-x) := 0;
	line::0 := Frameset::F_UL;
	line::(dx-x-1) := Frameset::F_UR;
	tty.move(x, y);
	tty.writes(line);
	for (i=y+1, dy-1) do
		tty.move(x, i); tty.writec(Frameset::F_VL);
		tty.move(dx-1, i); tty.writec(Frameset::F_VL);
	end
	line::0 := Frameset::F_LL;
	line::(dx-x-1) := Frameset::F_LR;
	tty.move(x, dy-1);
	tty.writes(line);
 end

 public scrselect(x, y, default, size, cs, fs, items) do
	var	max, len, off, red, k, i, j;

	init();
	len:= 0;
	max := 0; while (items[max]) do
		k := str.length(items[max][1]);
		if (k > len) len := k;
		max := max+1;
	end
	if (max <= size) size := 0;
	Colorset := cs-> cs: Dflcset;
	Frameset := fs-> fs: Dflfset;
	if (len > MAXWIDTH-1) do
		fini();
		return -2;
	end
	t.memfill(Spaces, '\s', len+4);
	Spaces::(len+4) := 0;
	tty.color(Colorset[C_BACKGROUND]);
	framebox(x, y, x+len+4, size-> y+size+2: y+max+2);
	i := default;
	red := 1;
	off := 0;
	if (\size) size := max;
	while (1) do
		if (red) do
			for (j=0, size) do
				if (j+off >= max) leave;
				writeitem(x+2, y+j+1, items[j+off][1], 0);
			end
			red := 0;
		end
		writeitem(x+2, y+i-off+1, items[i][1], 1);
		k := tty.readc();
		writeitem(x+2, y+i-off+1, items[i][1], 0);
		ie (k = 'N'-'@' \/ k = ttyctl.K_DOWN) do
			i := i+1;
			if (i-off >= size) do
				off := off+1; red := 1;
			end
			if (i >= max) do
				i := 0; off := 0; red := 1;
			end
		end
		else ie (k = 'P'-'@' \/ k = ttyctl.K_UP) do
			i := i-1;
			if (i<off) do
				off := off-1; red := 1;
			end
			if (i < 0) do
				i := max-1; off := max-size; red := 1;
			end
		end
		else ie (k = '\r' \/ k = ttyctl.K_RIGHT) do
			leave;
		end
		else ie (k = ttyctl.K_ESC \/ k = ttyctl.K_LEFT) do
			i := -1; leave;
		end
		else do
			for (j=0, max)
				if (k = items[j][0])
					leave;
			if (j<max) do
				i := j; leave;
			end
		end
	end
	tty.color(0x07);
	fini();
	return i;
 end

 public select(x, y, default, cs, fs, items)
	return self.scrselect(x, y, default, 0, cs, fs, items);

end

do end
