! TIDE -- Prompt class
! Copyright (C) 2000,2002 Nils M Holm. All rights reserved.
! See the file LICENSE for conditions of use.

module prompt();

public class prompt(t3x, string, ttyctl)

 object	t[t3x], str[string], tty[ttyctl];

 const	MAXLEN = 128;

 public struct	CSET = C_BACKGROUND, C_FRAME, C_TEXT, C_SOTEXT, C_SELECT;

 var	Colorset, Dflcset;

 init() do
	tty.init();
	tty.mode(1);
        Dflcset := [
                ttyctl.F_BLACK|ttyctl.B_GREY,   ! Background
                ttyctl.F_BLACK|ttyctl.B_GREY,   ! Frame
                ttyctl.F_BLACK|ttyctl.B_GREY,   ! Text
                ttyctl.F_GREY|ttyctl.B_BLACK,   ! SO text
                ttyctl.F_GREY|ttyctl.B_BLACK,   ! Select
        ];
 end

 fini() do
	tty.mode(0);
	tty.fini();
 end

 public input(x, y, lx, max, cs, buffer, xkeys) do
	var	red, k, j, i, nx;
	var	spaces::MAXLEN+1, tmp::MAXLEN+1;
	var	pt, off, len;
	var	dflt, done;

	if (lx > MAXLEN) return -1;
	init();
	t.memfill(spaces, '\s', lx);
	spaces::lx := 0;
	Colorset := cs-> cs: Dflcset;
	len := str.length(buffer);
	pt := len;
	off := pt-lx+1;
	if (off < 0) off := 0;
	red := 1;
	dflt := 1;
	nx := xkeys[0];
	done := 0;
	while (1) do
		if (done \/ red) do
			tty.move(x, y);
			tty.color(Colorset[dflt-> C_SELECT: C_TEXT]);
			str.copy(tmp, buffer);
			for (i=0, len) do
				j := tmp::i;
				if (j < '\s' \/ j > '~') j := '?';
				tmp::i := j;
			end
			ie (len-off > lx) do
				tmp::(off+lx) := 0;
				tty.writes(@tmp::off);
			end
			else do
				tty.writes(@tmp::off);
				tty.writes(@spaces::(len-off));
			end
			red := 0;
		end
		if (done) leave;
		tty.move(x+pt-off, y);
		k := tty.readc();
		for (i=0, nx) if (xkeys[i+1] = k) leave;
		if (i<nx) done := 1;
		ie (k = ttyctl.K_LEFT \/ k = 'P'-'@') do
			if (pt > 0) do
				pt := pt-1;
				if (pt < off) do
					off := pt;
					red := 1;
				end
			end
		end
		else ie (k = ttyctl.K_RIGHT \/ k = 'N'-'@') do
			if (pt < len) do
				pt := pt+1;
				if (pt-off >= lx) do
					off := off+1;
					red := 1;
				end
			end
		end
		else ie (k = ttyctl.K_DEL \/ k = 'D'-'@') do
			if (pt < len) do
				for (i=pt, len) buffer::i := buffer::(i+1);
				len := len-1;
				red := 1;
			end
		end
		else ie (k = '\b') do
			if (pt) do
				pt := pt-1;
				if (pt < off) off := pt;
				for (i=pt, len) buffer::i := buffer::(i+1);
				len := len-1;
				red := 1;
			end
		end
		else ie (k = 'U'-'@') do
			off := 0;
			len := 0;
			buffer::0 := 0;
			pt := 0;
			red := 1;
		end
		else ie (k = ttyctl.K_HOME \/ k = 'A'-'@') do
			red := off;
			pt := 0;
			off := 0;
		end
		else ie (k = ttyctl.K_END \/ k = 'E'-'@') do
			red := off;
			pt := len;
			off := pt-lx+1;
			if (off < 0) off := 0;
			red := red \= off;
		end
		else ie (k = ttyctl.K_ESC \/ k = '\r') do
			done := 1;
		end
		else if (k >= '\s' /\ k < 256 \/ k = 'V'-'@') do
			if (dflt) do
				pt := 0;
				len := 0;
				off := 0;
				buffer::0 := 0;
			end
			if (k = 'V'-'@') k := tty.readc();
			if (len >= max-1) loop;
			for (i=len+1, pt, -1) buffer::i := buffer::(i-1);
			buffer::pt := k;
			pt := pt+1;
			len := len+1;
			if (pt-off >= lx) off := off+1;
			red := 1;
		end
		if (dflt) do
			dflt := 0; red := 1;
		end
	end
	tty.color(0x07);
	fini();
	return k;
 end

end

do end
